#include <stdlib.h>
#include <math.h>
#include <string>
#include <vector>

#include "defs.h"
#include "math.h"

int mod (int a, int b) {
  for(;a<0;a+=b) {}
  for(;a>=b;a-=b) {}
  return a;
}

long modl (long a, long b) {
  for(;a<0;a+=b) {}
  for(;a>=b;a-=b) {}
  return a;
}

int pow (int a, int b) {
  int ris = 1;
  for (int t=0; t<b; t++) ris=ris*a;
  return ris;
}

long powl (int a, int b) {
  long ris = 1;
  for (int t=0; t<b; t++) ris=ris*a;
  return ris;
}

int norma(int a, int b) {  //attenzione: e' stata modificata, prima si chiamava compl(a,b)
  if (a<0) return norma(-a,-b);
  if (b<0) return norma(a,-b)+1;
  if (a==1 && b==1) return 0;
  if (a==0 || b==0) return 0;
  a > b ? a=a-b : b=b-a;
  return norma(a,b)+1;
}

long fact(int n) {
  long j=1;
  for(int i=1; i <= n; j=j*i++);
  return j;
}

//permuta (v[0],...,v[l]) secondo j
void perm(int * v, int l, long j) {
  int temp = 0;
  for (int i=0; i<=l; i++) {
    temp = mod (j, fact(l+1-i)) / fact(l-i);
    v[i] = 0;
    for (int z=0; z<=temp; z++, v[i]++) {
      int zz=0;
      while (zz==0) {
	int w=0;
	for (; v[w] != v[i]; w++) {}
	(w==i)? zz=1:v[i]++;
      }
    }
    v[i]--;
  }
}

//permuta ciclicamente (v[0],...,v[l]), trasformandolo in (v[step],...,v[step+l])
void perm_ciclicamente(int* v, int l, int step) {
  if (!step) return;
  if (step<0) perm_ciclicamente(v,l,step+l+1);
  int temp = v[0];
  for (int t=0; t<l; t++)
    v[t]=v[t+1];
  v[l] = temp;
  perm_ciclicamente(v, l, step-1);
}

std::vector<int> perm_inversa (const std::vector<int>& v) {
	std::vector<int> w(v.size());
  for (int i=0; i<v.size(); i++) w[v[i]]=i;
	return w;
}

//ordina gli elementi da v[0] a v[i], estremi inclusi (sono i+1)
void ordina(int* v, int i) {
  int sign=0;
  while (!sign) {
    sign=1;
    for (int j=0; j<i; j++)
      if (v[j+1]<v[j]) {
	int t=v[j]; v[j]=v[j+1]; v[j+1]=t;
	sign=0;
      }
  }
}

//prende gli elementi da v[0] a v[i], estremi inclusi (sono i+1), e sceglie la permutazione
//ciclica che parte dal primo fra i minimi
void ordina_ciclicamente(int* v, int i) {
  int min = 0;
  for (int t=0; t<=i; t++)
    if (v[t]<v[min]) min=t;
  for (int t=0; t<min; t++)
    un_ciclo(v,i);
}

void un_ciclo(int* v, int i) {
  int temp = v[0];
  for (int t=0; t<i; t++)
    v[t]=v[t+1];
  v[i]=temp;
}

//ritorna il segno della permutazione di 4 elementi data da (v[0],v[1],v[2],v[3])
int segno(const int* v) {
  int w[4]; for (int t=0; t<4; t++) w[t]=v[t];
  int trasposizioni=0;
  bool cambiamento;
  do {
    cambiamento = FALSE;
    for (int t=0; t<3; t++)
      if (w[t]>w[t+1]) {
        cambiamento = TRUE;
        trasposizioni++;
        std::swap(w[t],w[t+1]);
      }
  } while (cambiamento);
  return mod(trasposizioni,2);
}

//ritorna l'ordine della permutazione di 4 elementi data da (v[0],v[1],v[2],v[3])
int ordine(const int* v) {
  int fis=0;
  for (int i=0; i<4; i++) fis=fis+(v[i]==i);
  if (fis==4) return 1;
  if (fis==1) return 3;
  if (fis==2) return 2;
  if (fis==0 && v[v[0]]==0) return 2;
  else return 4;
}

void inverti(int* v) {
  int temp[4];
  for (int i=0; i<4; i++) temp[v[i]]=i;
  for (int i=0; i<4; i++) v[i]=temp[i];
}

//conta le cifre di a, incluso il segno negativo eventuale
//int cifre (long a) {
//  if (a<0) return cifre(-a)+1;
//  if (a<10) return 1;
//  return cifre(floor(a/10))+1;
//}

void lettera (int i, char* v) {
  const char alfabeto[]="abcdefghijklmnopqrstuvwxyz";
  strcpy(v, "1"); v[0]=alfabeto[i-1];
}

int ctoi (char* v, int i) {
  bool meno = (v[0]=='-');
  if (!i)
    for (int i=1; v[i]>=48 && v[i]<=57; i++) {}
  int risultato=0; int decimali=0;
  for (int j=i-1; j>=0; j--) {
    if ((v[j]>=48 && v[j]<=57))
      risultato+=(v[j]-48)*pow(10,decimali++);
  }
  if (meno) risultato*=-1;
  return risultato;
}

std::vector<int> abs(const std::vector<int>& v) {
	std::vector<int> ris = std::vector<int>(0);
	std::vector<int>::const_iterator i = v.begin();
	while (i!=v.end())
		ris.push_back(abs(*(i++)));
	return ris;
}

long double abs (long double n) {
  return (n>0) ? n : -n;
}

double abs (double n) {
  double ris = n>0 ? n : -n;
  return ris;
}

unsigned int MCD(int a, int b) {
  if (!a && !b) return 1;
  if (!a) return abs(b);
  if (!b) return abs(a);
  unsigned int mcd=1; a=abs(a); b=abs(b);
  for (unsigned int i=2; i<=a && i<=b; i++)
    if (!mod(a,i) && !mod(b,i)) {
      mcd*=i; a/=i; b/=i; i=1;
    }
  return mcd;
}

unsigned int mcm(int a, int b) {
  if (!a || !b) return 0;
  unsigned int m=abs(a)*abs(b);
  return (m/MCD(a,b));
}

unsigned long MCD(unsigned long a, unsigned long b) {
  if (!a && !b) return 1;
  if (!a) return b;
  if (!b) return a;
  long mcd=1;
  for (long i=2; i<=a && i<=b; i++)
    if (!modl(a,i) && !modl(b,i)) {
      mcd*=i; a/=i; b/=i; i=1;
    }
  return mcd;
}

int phi(int a) {
  int res=1;
  for (int i=2; i<a; i++)
    if (MCD(a,i)==1) res++;
  return res;
}

bool rapporti_uguali (int a, int b, int c, int d) {
  if ((b==0 && d==0) || (a==0 && c==0) || (!a && !b) || (!c && !d)) return TRUE;
  if (!a || !b || !c || !d) return FALSE;
  if (a*c<0) {c=-c;d=-d;}
  int mcd1=MCD(a,b); int mcd2=MCD(c,d);
  if (a/mcd1 == c/mcd2 && b/mcd1 == d/mcd2) return TRUE;
  return FALSE;
}

//scambia i due valori
void swap(int& v, int& w) {
  int temp = v;
  v = w;
  w = temp;
}

//scambia i due valori
void swap(double& v, double& w) {
  double temp = v;
  v = w;
  w = temp;
}

bool intervallo::contiene (int i) {
  if (a<=b) {
    if (i>=a && i<=b) return TRUE;
    return FALSE;
  }
  if (b==-1 && i>=a) return TRUE;
  return FALSE;
}

void intervallo::interseca (intervallo I) {
  if (I.a>a) a=I.a;
  if (b == -1) b=I.b;
  else if (I.b<b && I.b!=-1) b=I.b;
}
