#if !defined (OGRAPH_H)
#define OGRAPH_H

#include <string>
#include <iostream>

#include "defs.h"
#include "igraph.h"
#include "faces.h"


class overtice:public ivertice{ 
 protected:
  torsione tor[4];
 public:
  overtice();
  torsione get_tor(int i) const {return tor[i];}
  void set_tor(int i, torsione tr) {tor[i]=tr;}
  void tor_add(int i, int tr) {tor[i]+=tr;}
  void tor_invert(int i) {tor[i].invert();}
  bool falso(int i) const {return tor[i].falsa();}

	virtual ~overtice() {}
  virtual overtice* clone() const {return new overtice(*this);}
  virtual bool operator==(const vertice& y) const;
};

class grafo3;

class ografo:public igrafo{
 protected:
  std::vector<faccia> ff;
 public:
  ografo():igrafo(), ff() {}
  ografo(const ografo& o);
  ografo(std::istream&, int tipo_formato=0);
  ografo(const igrafo& ig, const std::vector<torsione>& tr);
  
  virtual ~ografo() {}
  ografo& operator=(const ografo& o);
  virtual ografo* clone() const {return new ografo(*this);}
  
  bool falso(int i, int j) const {return v[i]->falso(j);}
  bool vero() const;
  void set_facce();

  bool scheletro() const ;
  bool pseudo_minimale(std::string* ris=0) const ;
  int num_1scheletro() const;
	int eulero() const;
  
	ografo& MP(int, int);
  int disc_replacement(int lati, int num_faccia_con_lati_richiesti, 
												bool tipo=0, bool solo_cl_zero=0); //ATTENZIONE
  int disc_replacement(int num_faccia, bool tipo=0); //differenze di tipo 'bool' e 'int'!

	bool buca(int num_faccia);
	bool attacca_toro_di_bordo(int num);
	bool collassa_triodo_di_bordo(int num);
	ografo& scheletro2spina();

  bool set_faccia_su_01(int num_faccia);
	
  bool fill(int num_spig, int p, int q);
  bool drill(int num_spig);
	void change_triod(int num_spig, int p, int q);
  
	bool chiusa(const faccia& f) const;
  teta facce_su_spigolo(int vert, int usc) const;
	const std::vector<faccia>& get_ff() const {return ff;}
  bool colori_facce_ammissibili() const;

	std::vector<int> spigoli_falsi() const;  //ritorna gli spigoli falsi
  std::vector<int> spigoli_con_mobius_triplet() const;
  tensor2 triodi() const;

  //classi friends:
	friend std::vector<teta> get_teta(const ografo&, bool colora_progressivo = TRUE, 
                               bool orientazioni_concordi = TRUE);
  friend grafo3 grafo3_di_superficie_da_colori_facce(ografo o, bool con_cicli = FALSE);
  
	//sovrascritte:
  virtual void trasforma (const trasformazione&);
  virtual bool operator<(const grafo& y) const;
  
  virtual void scrivi_facce(std::ostream& f) const;
	virtual void scrivi_geometria(std::ostream & f) const {}
  virtual void scrivi(std::ostream& f, int tipo_formato=0) const;

 protected:
  virtual void Cz(int vert, const int* z, int delta_tor=0);

 private:
  void rimuovi(int i);
  void ordina_ogni_vertice();
};

tensor2 orbita (const ografo& o, int spigolo);

teta get_teta(const ografo&, int, int, int=0);

#endif
