#include <stdlib.h>
#include <vector>
#include <algorithm>

#include "templates.h"

//template per le permutazioni di vettori
template<class T> void permuta(std::vector<T>& v, const std::vector<int>& p) {
  const int l = v.size();
  std::vector<T> temp(l);
  for (int i=0; i<l; i++)
    temp[p[i]] = v[i];
  for (int i=0; i<l; i++)
    v[i] = temp[i];
}

//template che dice se gli elementi del contenitore T sono tutti diversi
template<class T> bool tutti_diversi(const T& t) {
  typename T::const_iterator p = t.begin();
  while (p!=t.end())
    if (count(t.begin(), t.end(), *(p++))>1) return FALSE;
  return TRUE;
}

//ordina ed elimina duplicati
template<class T> void elimina_duplicati(T& t) {
	sort(t.begin(), t.end());
	typename T::iterator p = unique(t.begin(), t.end());
	t.erase(p,t.end());
}

template<class T> void disalloca(std::vector<T>& v) {
	const int sz = v.size();
	for (int i=0; i<sz; i++)
		delete v[i];
}
